<template>
  <q-dialog persistent transition-show="flip-down" transition-hide="flip-up" @hide="hide" v-model="show">
    <q-card>
        <q-toolbar>
          <q-toolbar-title class="text-center">{{ title }}</q-toolbar-title>
          <q-btn dense flat icon="close" v-close-popup>
            <q-tooltip content-class="bg-white text-primary">Cerrar</q-tooltip>
          </q-btn>
        </q-toolbar>
        <q-form ref="form" class="q-gutter-md" @submit="onSubmit" @reset="onReset">
          <q-card-section class="row q-gutter-xs">
            <div class="col">
              <q-select
                outlined
                clearable
                dense
                options-dense
                use-input
                label="Nombre del local *"
                :readonly="editing"
                :options="optionsLocal"
                :rules="[val => !!val || 'Campo es requerido.']"
                @filter="filterLocals"
                v-model="draft.local.option"
              >
                <template v-slot:no-option>
                  <q-item>
                    <q-item-section class="text-grey">
                      No results
                    </q-item-section>
                  </q-item>
                </template>
              </q-select>
            </div>
            <div class="col">
              <q-select
                outlined
                clearable
                dense
                options-dense
                use-input
                label="Nombre del producto *"
                :readonly="editing"
                :options="optionsProduct"
                :rules="[val => !!val || 'Campo es requerido.']"
                @filter="filterProducts"
                @input="change"
                v-model="draft.product.option"
              >
                <template v-slot:no-option>
                  <q-item>
                    <q-item-section class="text-grey">
                      No results
                    </q-item-section>
                  </q-item>
                </template>
              </q-select>
              <q-input
                outlined
                dense
                readonly
                label="Marca *"
                :rules="[val => !!val || 'Campo es requerido.']"
                v-model="draft.product.brand"
              />
              <q-input
                outlined
                dense
                readonly
                label="Descripción *"
                :rules="[val => !!val || 'Campo es requerido.']"
                v-model="draft.product.description"
              />
              <q-input
                outlined
                dense
                label="Precio *"
                mask="#.##"
                fill-mask="0"
                reverse-fill-mask
                input-class="text-right"
                :rules="[val => !!val || 'Campo es requerido.']"
                v-model.number="draft.product.price"
              />
            </div>
          </q-card-section>
          <q-card-actions>
            <q-btn flat label="Limpiar" type="reset" color="primary" class="q-ml-sm"/>
            <q-btn :label="submit" type="submit" color="primary"/>
          </q-card-actions>
        </q-form>
      </q-card>
  </q-dialog>
</template>

<script>
export default {
  props: ['title', 'ranking', 'editing'],
  data () {
    return {
      show: true,
      draft: this.ranking,
      locals: [],
      copyLocals: [],
      products: [],
      copyProducts: [],
      country: 'VE',
      city: 'VE-L',
      type: 'beer'
    }
  },
  created () {
    const db = this.$firebase.firestore()
    db.collection(`locals/countries/${this.country}/cities/${this.city}`).orderBy('name')
      .onSnapshot(querySnapshot => {
        this.locals = []
        querySnapshot.forEach(doc => {
          let local = { id: doc.id }
          for (let key in doc.data()) {
            local[key] = doc.data()[key]
          }
          this.locals.push(local)
        })
        this.copyLocals = JSON.parse(JSON.stringify(this.locals))
      })
    db.collection(`products/countries/${this.country}/types/${this.type}`).orderBy('name')
      .onSnapshot(querySnapshot => {
        this.products = []
        querySnapshot.forEach(doc => {
          let product = { id: doc.id }
          for (let key in doc.data()) {
            product[key] = doc.data()[key]
          }
          this.products.push(product)
        })
        this.copyLocals = JSON.parse(JSON.stringify(this.locals))
      })
  },
  watch: {
    ranking: function (data) {
      this.draft = JSON.parse(JSON.stringify(data))
    }
  },
  computed: {
    submit () {
      return this.editing ? 'Actualizar' : 'Guardar'
    },
    optionsLocal: {
      get () {
        return this.copyLocals.map(local => {
          return {
            label: local.name,
            value: local
          }
        })
      },
      set (value) {
        this.copyLocals = value
      }
    },
    optionsProduct: {
      get () {
        return this.copyProducts.map(product => {
          return {
            label: `${product.brand} ${product.name}`,
            value: product
          }
        })
      },
      set (value) {
        this.copyProducts = value
      }
    }
  },
  methods: {
    filterLocals (search, update) {
      if (search === '') {
        update(() => {
          this.optionsLocal = JSON.parse(JSON.stringify(this.locals))
        })
        return
      }

      update(() => {
        this.optionsLocal = this.locals.filter(v => v.name.toLowerCase().indexOf(search.toLowerCase()) > -1)
      })
    },
    filterProducts (search, update) {
      if (search === '') {
        update(() => {
          this.optionsProduct = JSON.parse(JSON.stringify(this.products))
        })
        return
      }

      update(() => {
        this.optionsProduct = this.products.filter(v => v.name.toLowerCase().indexOf(search.toLowerCase()) > -1)
      })
    },
    change (product) {
      if (product === null) {
        this.draft.product.brand = ''
        this.draft.product.description = ''
      } else {
        this.draft.product.brand = product.value.brand
        this.draft.product.description = product.value.description
        if (this.editing) {
          this.draft.product.price = 0
        }
      }
    },
    hide () {
      this.show = false
      this.$router.push({ name: 'ranking' })
    },
    async onSubmit () {
      await this.$refs.form.validate().then(success => {
        if (success) {
          this.$emit('save', {
            product: this.draft.product,
            local: this.draft.local
          })
          // pendiente crear la validación para cuando un local, ya tenga el producto registrado
        }
      })
      this.hide()
    },
    onReset () {
      this.draft = JSON.parse(JSON.stringify(this.ranking))
    }
  }
}
</script>

<style lang="stylus" scoped>
  .q-card
    width 600px
</style>
